using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

/// <summary>
/// Implements the secondary effect of Phantom Force, which makes the user semi-invulnerable on the first turn
/// and attacks on the second turn.
/// </summary>
[Script(ScriptCategory.Move, "phantom_force")]
public class PhantomForce : Script, IScriptPreventMove, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<PhantomForceCharge>())
            return;

        move.User.Volatile.Add(new PhantomForceCharge(move.User));
        move.MoveChoice.SetAdditionalData("phantom_force_charge", true);
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("phantom_force_charge",
            new Dictionary<string, object>
            {
                { "user", move.User },
            }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        if (move.User.Volatile.Contains<PhantomForceCharge>())
            return;

        move.User.Volatile.Add(new PhantomForceCharge(move.User));
    }
}